// --------------------------------------------------------------------------------------
//
// frmStanze(Stanze.CPP)                                           Ulrich Mller 01.06.02
//                                                                 PCS1700 C++Builder 4.0
// Stanzmaschine mit Transportband (51 663)
// mit FishFa30.H/CPP auf Basis von umFish30.DLL
//
// --------------------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Stanze.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmStanze *frmStanze;
//---------------------------------------------------------------------------
__fastcall TfrmStanze::TfrmStanze(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------



// --- Stanze : Routine fr den Modellbetrieb, kann weitere Funktionen aufrufen --------

void __fastcall TfrmStanze::Action()
{
    ft.ClearMotors();
    ft.SetMotor(mStanze, csAuf);
    ft.WaitForInput(eOben);
    ft.SetMotor(mStanze, ftiAus);
    ft.SetMotor(mLampen, ftiEin);
    do
    {
        lblStatus->Caption = "Wartet";
        ft.WaitForLow(ePhotoV);
        ft.Pause(500);
        lblStatus->Caption = "Zur Stanze";
        ft.SetMotor(mBand, cbVor);
        ft.WaitForLow(ePhotoS);
        ft.SetMotor(mBand, ftiAus);

        lblStatus->Caption = "Stanzen";
        ft.SetMotor(mStanze, csAb);
        ft.WaitForInput(eUnten);
        ft.SetMotor(mStanze, ftiAus);
        ft.Pause(1000);
        ft.SetMotor(mStanze, csAuf);
        ft.WaitForInput(eOben);
        ft.SetMotor(mStanze, ftiAus);

        lblStatus->Caption = "Zurck",
        ft.SetMotor(mBand, cbRuck);
        ft.WaitForInput(ePhotoV, false);
        ft.Pause(300);
        ft.SetMotor(mBand, ftiAus);
    } while (!ft.Finish());
}

//---- FormCloseQuery : Programmende sperren, wenn noch Modellbetrieb ---

void __fastcall TfrmStanze::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if(cmdEnde->Caption == "&HALT") CanClose = false;
}

//---- cmdEndeClick : Beenden Modellbetrieb, wenn HALT-Button, sonst Programmende ------

void __fastcall TfrmStanze::cmdEndeClick(TObject *Sender)
{
    if(cmdEnde->Caption == "&HALT") ft.NotHalt = true; else Close();
}

//--- cmdActionClick : Steuern des Modellbetriebes ---------------------------

void __fastcall TfrmStanze::cmdActionClick(TObject *Sender)
{
    try
    {
        ft.OpenInterface("COM1");                    // --- PortName = COM1
        cmdAction->Enabled = false;
        cmdEnde->Caption = "&HALT";
        lblStatus->Caption = "luft";
        cmdEnde->SetFocus();

        Action();

        ft.ClearMotors();
        lblStatus->Caption = "START/ENDE";
    }
    catch(TFishFaceException& fte)
    {
        lblStatus->Caption = fte.Text;
        ft.NotHalt = true;
    }
    ft.CloseInterface();
    cmdAction->Enabled = true;
    cmdEnde->Caption = "&ENDE";
}

